# Generated by Django 4.1.7 on 2023-04-13 16:54

from django.db import migrations, models
import django.db.models.deletion
import django_common_task_system.models


class Migration(migrations.Migration):

    dependencies = [
        ('django_common_task_system', '0003_alter_taskschedulelog_schedule'),
    ]

    operations = [
        migrations.CreateModel(
            name='TaskScheduleQueue',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100, unique=True, verbose_name='队列名称')),
                ('code', models.CharField(max_length=100, unique=True, validators=[django_common_task_system.models.code_validator], verbose_name='队列编码')),
                ('status', models.BooleanField(default=True, verbose_name='状态')),
                ('module', models.CharField(choices=[('queue.Queue', '普通队列'), ('queue.LifoQueue', '后进先出队列'), ('queue.PriorityQueue', '优先级队列'), ('_queue.SimpleQueue', '简单队列'), ('django_common_task_system.system_task.queue.RedisListQueue', 'Redis List队列')], default='queue.Queue', max_length=100, verbose_name='队列类型')),
                ('config', models.JSONField(blank=True, default=dict, null=True, verbose_name='配置')),
                ('create_time', models.DateTimeField(auto_now_add=True, verbose_name='创建时间')),
                ('update_time', models.DateTimeField(auto_now=True, verbose_name='更新时间')),
            ],
            options={
                'verbose_name': '任务队列',
                'verbose_name_plural': '任务队列',
                'db_table': 'task_schedule_queue',
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='taskschedulelog',
            name='queue',
            field=models.CharField(default='opening', max_length=100, verbose_name='队列'),
        ),
        migrations.CreateModel(
            name='TaskScheduleProducer',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100, verbose_name='生产者名称')),
                ('filters', models.JSONField(verbose_name='过滤器')),
                ('lte_now', models.BooleanField(default=True, verbose_name='小于等于当前时间')),
                ('status', models.BooleanField(default=True, verbose_name='启用状态')),
                ('create_time', models.DateTimeField(auto_now_add=True, verbose_name='创建时间')),
                ('update_time', models.DateTimeField(auto_now=True, verbose_name='更新时间')),
                ('queue', models.ForeignKey(db_constraint=False, on_delete=django.db.models.deletion.CASCADE, related_name='producers', to='django_common_task_system.taskschedulequeue', verbose_name='队列')),
            ],
            options={
                'verbose_name': '计划生产',
                'verbose_name_plural': '计划生产',
                'db_table': 'task_schedule_producer',
                'abstract': False,
            },
        ),
    ]
